/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package GUIAzuriranjeStrategija;

import GUIAzuriranjeStrategija.GUIOsluskivaci.*;
import Kontroler_client.IntArray;
import Kontroler_client.Kontroler;
import Kontroler_client.Kontroler_Service;
import Kontroler_client.ListaGeneralDObject;

import Kontroler_client.Strategija;
import Kontroler_client.TransferObjekatListaStrategija;

import Kontroler_client.TransferObjekatStrategija;
import Kontroler_client.TransferObjekatStrategijaMatrica;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import java.util.List;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;


/**
 *
 * @author Sinisa
 */
public class KontrolerGUIAzuriranjeStrategija {
     FXMLDocumentController fxcon;
     
     //TransferObjekatLogikaSahovskaTabla tolst = new TransferObjekatLogikaSahovskaTabla();
     int brojacRedosleda = 0;
     static int strategija[] = new int[8];     
     
     boolean prviprolaz = false;
     
     Kontroler_Service service;
     Kontroler kal;
     
            
     public KontrolerGUIAzuriranjeStrategija(FXMLDocumentController fxcon) throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException
        {this.fxcon = fxcon;
         
        service = new Kontroler_Service();
        kal = service.getKontrolerPort();
        
         // o1.
         this.fxcon.novaStrategija.setOnAction(new OsluskivacNovaStrategija(this)); 
         // o.2
         this.fxcon.dodajStrategiju.setOnAction(new OsluskivacDodajNovuStrategiju(this)); 
         // o.3
         this.fxcon.obrisiStrategiju.setOnAction(new OsluskivacObrisiStrategiju(this)); 
         // o.4
         this.fxcon.kbStrategije.setOnAction(new OsluskivacKBStrategije(this)); 
        
        // Kreiraj objekat logike sahovske table
       // LogikaSahovskaTabla st = new LogikaSahovskaTabla();
       // tolst.setLst(st);
        // 1. Inicijalizacija GUI sahovske table
        inicijalizacijaGUISahovskeTable(true); 
        // 2.
        osveziKBStrategije(null);     
        // 3.
        napuniGUISahovskaTabla();
    } 
     
    // 1, o.1.1.1,  
    public void inicijalizacijaGUISahovskeTable(boolean signal)
    {  brojacRedosleda = 0;
       try {  // 1.1
              odrediSvetlinuPolja();
           } catch (NoSuchFieldException | IllegalArgumentException | IllegalAccessException ex) 
             { Logger.getLogger(KontrolerGUIAzuriranjeStrategija.class.getName()).log(Level.SEVERE, null, ex); }
       
         try { // 1.2 
               ocistiPolja();
             } catch (NoSuchFieldException ex) 
              { Logger.getLogger(KontrolerGUIAzuriranjeStrategija.class.getName()).log(Level.SEVERE, null, ex); }
       
       try { // 1.3    
             odrediOsluskivaceNaPolja(signal);
           } catch (NoSuchFieldException | IllegalArgumentException | IllegalAccessException ex) 
             { Logger.getLogger(KontrolerGUIAzuriranjeStrategija.class.getName()).log(Level.SEVERE, null, ex);}
      
       
     // 1.4  
      postaviSlikuBroja(vratiSliku("beli_skakac"),3,3);
       
    } 

   // 2, o.2.1.1.3  
   void osveziKBStrategije(Strategija str)
  { TransferObjekatListaStrategija tols = new TransferObjekatListaStrategija();
    
    // o.2.1.1.3.1 (SO) 
    tols.setLs(new ListaGeneralDObject());
    tols = kal.vratiListuStrategija(tols);
    
    ObservableList<Strategija> list = FXCollections.observableArrayList();
    list.addAll((List)tols.getLs().getLs());
    fxcon.kbStrategije.setItems(list);
    
    // Strategija str = fxcon.kbStrategije.getValue();
    // strategija = konvertujIDStrategijauNizStrategija(str.getIdStrategija());
    
    if (str == null)
      {fxcon.kbStrategije.getSelectionModel().selectLast();
       Strategija str1 = fxcon.kbStrategije.getValue();
       strategija = konvertujStringIDUNizID(str1.getIdStrategija());
      }  
    else
      {fxcon.kbStrategije.getSelectionModel().select(str);
       strategija = konvertujStringIDUNizID(str.getIdStrategija()); 
      }
  }     

  

  // 1.2
   void ocistiPolja() throws NoSuchFieldException
      {     
        for (int x = 0; x < 8; x++)
           { for (int y = 0; y < 8; y++)
            {   String nazivDugmeta = "p" + x + y;
                Class cls = this.fxcon.getClass(); 
                Field field = cls.getDeclaredField(nazivDugmeta);
                // 1.2.1
                postaviSlikuBroja(null,x,y);
               
            }
           }
      } 

   
   // 1.3.1 
   void odrediRedosledStanja(Dugme d)
    {  // 1.3.1.1
       if (d.odrediStanje(brojacRedosleda))
        { brojacRedosleda++; 
          // 1.3.1.2
          postaviSlikuBroja(vratiSliku("" + brojacRedosleda),d.x,d.y);
        }
    }  
 
 
   
 // 1.3
 void odrediOsluskivaceNaPolja(boolean signal) throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException
  {     
        for (int x = 0; x < 8; x++)
           { for (int y = 0; y < 8; y++)
            {   String nazivDugmeta = "p" + x + y;
                Class cls = this.fxcon.getClass(); 
                Field field = cls.getDeclaredField(nazivDugmeta);
                Button b = (Button) field.get(this.fxcon); 
                Dugme d = new Dugme (b,x,y,nazivDugmeta);
                if (signal)
                   // 1.3.1
                   b.setOnAction(e -> odrediRedosledStanja(d));
                else 
                   b.setOnAction(e -> System.out.println("Polje nije aktivno!!!")); 
            }
           } 
  }      
 
 // o.2.1.1 
 public void dodajNovuStrategiju()
   { //int[] strategijapom = strategija;
     TransferObjekatStrategija tos = new TransferObjekatStrategija();
     
     if (brojacRedosleda == 8)
     {   String idStrategija = konvertujNizIDUStringID(strategija);
         int idKorisnik = Integer.parseInt(fxcon.idKorisnika.getText());
         Strategija str = new Strategija();
         str.setIdStrategija(idStrategija);
         str.setIdKorisnik(idKorisnik);
         tos.setStr(str);
         // o.2.1.1.1 (SO)
         tos = kal.dodajStrategiju(tos);
         if (tos.isSignal())        
           {  // o.2.1.1.3 
             osveziKBStrategije(str);     
           }
         poruka(tos.getPoruka());
            //strategija = strategijapom;
             
            //Strategija s = new Strategija();
            // o.2.1.1.4 (SO) 
            //s.konvertujNizStrategijaUIDStrategija(strategija);
             
            // fxcon.kbStrategije.getSelectionModel().select(str);
            // o.2.1.1.5 
         //napuniGUISahovskaTabla(); 
     }     
     else
        poruka("Ne moze se dodati strategija, nisu sva polja popunjena!!!");
   }      
 

 public void obrisiStrategiju()
   {   
     TransferObjekatStrategija tos = new TransferObjekatStrategija();
     String idStrategija = konvertujNizIDUStringID(strategija);
     //int idKorisnik = Integer.parseInt(fxcon.idKorisnika.getText());
     Strategija str = new Strategija();
     str.setIdStrategija(idStrategija);
     tos.setStr(str);
       
     tos = kal.obrisiStrategiju(tos);
         if (tos.isSignal())        
           { // o.2.1.1.2 
             // poruka(" strategija!!!");
             // o.2.1.1.3 
             osveziKBStrategije(null);     
           }
         poruka(tos.getPoruka());
       
   }
 
 
 // 3, o.2.1.1.5
 public int napuniGUISahovskaTabla() throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException
   { Strategija str = fxcon.kbStrategije.getValue(); 
     inicijalizacijaGUISahovskeTable(false);   
     if (str == null)
         return 0;
     
     
     TransferObjekatStrategijaMatrica tos = new TransferObjekatStrategijaMatrica();
     tos.setStr(str);
     // SO!!! 
     tos = kal.vratiMatricuSahovskeTableSaStrategijom(tos);
     
     
     int mat[][] = konvertujListArrIntUMatricu (tos.getMatrica());   
     try {  
             oznaciPolja(mat);
         } catch (NoSuchFieldException | IllegalArgumentException | IllegalAccessException ex) {
             Logger.getLogger(KontrolerGUIAzuriranjeStrategija.class.getName()).log(Level.SEVERE, null, ex);
         }
     postaviSlikuBroja(vratiSliku("beli_skakac"),3,3);     
     brojacRedosleda = 8;
     
     if (prviprolaz == false)
        {prviprolaz = true;}     
     else
        { 
     
         // SO!!!
         tos = kal.vratiMatricuSahovskeTableSaPutanjom(tos);   
         if (tos.getMatrica().size() != 0)
           { mat = konvertujListArrIntUMatricu(tos.getMatrica());   
             SSFX1.guicon.kngui.postaviMat(mat);
             //SSFX1.guicon.start.fire();
             SSFX1.guicon.kngui.inicijalizacijaGUISahovskeTable();
             SSFX1.guicon.kngui.oznaciPolja(mat);
             SSFX1.guicon.kngui.poruka("Putanja procitana iz baze!!!");
           }  
         else
           SSFX1.guicon.start.fire();  
        }
     
     
     return 1;
   }      

  // 1.1 (atomska metoda, refleksija, CSS)
 void odrediSvetlinuPolja() throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException
  {
    for (int x = 0; x < 8; x++)
             { for (int y = 0; y < 8; y++)
                {   boolean svetlina = ( (x + y) % 2 != 0 );
                    String nazivDugmeta = "p" + x + y;
                    Class cls = this.fxcon.getClass(); 
                    Field field = cls.getDeclaredField(nazivDugmeta);
                    Button b = (Button) field.get(this.fxcon); 
                    if (svetlina)
                     { b.getStyleClass().removeAll("konjicevskok-kraj");
                       b.getStyleClass().add("konjicevskok-polje-svetlo");
                     } 
                    else
                     { b.getStyleClass().removeAll("konjicevskok-kraj");
                       b.getStyleClass().add("konjicevskok-polje-tamno");
                     }  
                }   
             }
  } 
 
  // 1.2.1, 1.3.1.2, 1.4   (atomska metoda, refleksija)
     public void postaviSlikuBroja(Image img, int x, int y)
    {   
        Button b = null;
        String nazivDugmeta = "p" + x + y;
        
        Class cls = this.fxcon.getClass(); 
        try { 
            Field field = cls.getDeclaredField(nazivDugmeta);
            b = (Button) field.get(this.fxcon);
        } catch (NoSuchFieldException | SecurityException | IllegalArgumentException | IllegalAccessException ex) {
            Logger.getLogger(FXMLDocumentController.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        if (img != null)
            b.setGraphic( new ImageView ( img ) );
        else
            b.setGraphic( new ImageView());
    } 
 
// o.2.1.1.2 (atomska metoda) 
 void poruka(String poruka)
 {
    Alert infoAlert = new Alert(Alert.AlertType.INFORMATION);
    infoAlert.setTitle("Poruka:");
    infoAlert.setHeaderText(null); 
    infoAlert.setContentText(poruka); 
    infoAlert.showAndWait();  
 }     
 
 // strategija moze biti predstavljena preko idStrategija 
 // ili preko niza od 8 brojeva.
 public int[] konvertujStringIDUNizID(String idStrategija)
    { int strategija[] = new int[8];  
      for(int i=0;i<idStrategija.length();i++)
        strategija[i] = Integer.parseInt(idStrategija.charAt(i) + "");
      return strategija;
    }
 
  public List<Integer> konvertujStringIDUListuID(String idStrategija)
    { List<Integer> li = new ArrayList<>(); 
      for(int i=0;i<idStrategija.length();i++)
        li.add(Integer.parseInt(idStrategija.charAt(i) + ""));
      return li;
    }
 
    public String konvertujNizIDUStringID(int [] strategija)
    { String idStrategija = ""; 
      for(int i=0;i<strategija.length;i++)
        idStrategija = idStrategija + strategija[i];
      return idStrategija;
    }
  

void oznaciPolja(int mat[][]) throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException
      {  for (int x = 0; x < 8; x++)
           { for (int y = 0; y < 8; y++)
            {   if (mat[x][y] == 0)
                    postaviSlikuBroja(null,x,y);
                if (mat[x][y] != 0)
                 { postaviSlikuBroja(vratiSliku(String.valueOf(mat[x][y])),x,y);
                 }
            }
           }
      } 
    
    public Image vratiSliku(String broj)
    {   String location = "assets/icons/";
        String filename =  broj + ".png";
        Image slikaBroja = new Image(location + filename);
        return slikaBroja;
    }  

int [][] konvertujListArrIntUMatricu (List<IntArray> lia)
{ int mat[][] = new int [8][8];
  for(int i = 0; i<8;i++)    
           for(int j = 0; j<8;j++)    
               mat[i][j] = lia.get(i).getItem().get(j);  

  
   
  return mat;
}   
    
    
}

class Dugme
{ 
  public Dugme(Button b,int x,int y,String nazivDugmeta)
   {  this.b = b;
      this.x = x;
      this.y = y;  
      this.nazivDugmeta = nazivDugmeta;
   }            
  Button b;
  int x;
  int y;
  String nazivDugmeta;

  // 1.3.1.1 atomska metoda.
  public boolean odrediStanje(int brojacRedosleda)
   {  boolean signal = false; // Polazi se od pretpostavke da nije izabrano odgovarajuce polje.
      //redosled = brojacRedosleda;
      if (brojacRedosleda == 8)
          return signal;
      if (x == 4 && y == 5) // s1
       { KontrolerGUIAzuriranjeStrategija.strategija[brojacRedosleda] = 1; signal = true;} 
      if (x == 5 && y == 4) // s2
       { KontrolerGUIAzuriranjeStrategija.strategija[brojacRedosleda] = 2; signal = true;}
      if (x == 5 && y == 2) // s3
       { KontrolerGUIAzuriranjeStrategija.strategija[brojacRedosleda] = 3; signal = true;}
      if (x == 4 && y == 1) // s4
       { KontrolerGUIAzuriranjeStrategija.strategija[brojacRedosleda] = 4; signal = true;}
      if (x == 2 && y == 1) // s5
       { KontrolerGUIAzuriranjeStrategija.strategija[brojacRedosleda] = 5; signal = true;}
      if (x == 1 && y == 2) // s6
       { KontrolerGUIAzuriranjeStrategija.strategija[brojacRedosleda] = 6; signal = true;}
      if (x == 1 && y == 4) // s7
       { KontrolerGUIAzuriranjeStrategija.strategija[brojacRedosleda] = 7; signal = true;}
      if (x == 2 && y == 5) // s8
       { KontrolerGUIAzuriranjeStrategija.strategija[brojacRedosleda] = 8; signal = true;}
      return signal;
   }   
  
}


