/* Napravi kontroler GUI koji ce da bude izmedje FXML kontrolera i poslovne logike. 
Napravi da se bira strategija. Napravi osluskivace i uradi projektovanje top-down.
Omoguci cuvanje razlicitih strategija i putanja preko datoteka.

*/

package GUIAzuriranjeStrategija;

import java.net.URL;
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;

/**
 *
 * @author Sinisa
 */
public class SSFX1 extends Application {
    FXMLDocumentController con;
    static GUIGlavniMeni.FXMLDocumentController guicon;
    String idKorisnika;
    @Override
    public void start(Stage stage) throws Exception {
        //root = FXMLLoader.load(getClass().getResource("FXMLDocument.fxml"));
        
        
        String resourcePath = "FXMLDocument.fxml";
        URL location = getClass().getResource(resourcePath);
        FXMLLoader fxmlLoader = new FXMLLoader(location);
        Parent root = fxmlLoader.load();
        con = (FXMLDocumentController) fxmlLoader.getController();
        
        con.idKorisnika.setText(idKorisnika);
        
        Scene scene = new Scene(root);
        scene.getStylesheets().add("assets/stylesheet.css");
        stage.setScene(scene);
        
        stage.setTitle("Ažuriranje strategije");
        stage.show();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
    public FXMLDocumentController getController()
    { return con;} 
        
    public void setGUIController(GUIGlavniMeni.FXMLDocumentController guicon)    
      {this.guicon = guicon;}   
    
    public void postaviKorisnika (String idKorisnika)
     {
       this.idKorisnika = idKorisnika;
     }     
    
    public String vratiIDKorisnika ()
     {
       return idKorisnika;
     }
    
}
