/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package GUIGlavniMeni;

import GUIGlavniMeni.Osluskivaci.OsluskivacObrisiPutanju;
import GUIGlavniMeni.Osluskivaci.OsluskivacStart;
import GUIGlavniMeni.Osluskivaci.OsluskivacIzlaz;
import GUIGlavniMeni.Osluskivaci.OsluskivacDodajPutanju;
import GUIGlavniMeni.Osluskivaci.OsluskivacAutorPrograma;
import GUIGlavniMeni.Osluskivaci.OsluskivacAzuriranjeStrategija;
import Kontroler_client.IntArray;
import Kontroler_client.Kontroler;
import Kontroler_client.Kontroler_Service;
import Kontroler_client.Strategija;
import Kontroler_client.TransferObjekatStrategijaMatrica;
import Kontroler_client.TransferObjekatStrategijaPutanja;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Platform;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;


/**
 *
 * @author Sinisa
 */
public class KontrolerGUIGlavniMeni {
     FXMLDocumentController fxcon;
     
     int brojacRedosleda = 0;
     static int strategija[] = new int[8];     
     
     String tekucaStrategija = "12345678";
     OsluskivacAzuriranjeStrategija oas;
     
     int brojKorakaPutanje;
     
     int mat[][];
     
     Kontroler_Service service;
     Kontroler kal;
     
     
     public KontrolerGUIGlavniMeni(FXMLDocumentController fxcon) throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException
        {
         service = new Kontroler_Service();
         kal = service.getKontrolerPort();   
            
         this.fxcon = fxcon;
         oas = new OsluskivacAzuriranjeStrategija(fxcon);
         // Glavni meni: 
         // 1. Skakacev skok
            // 1.1 Start
            this.fxcon.start.setOnAction(new OsluskivacStart(this));
         // 2. Strategije
            // 2.1 Azuriranje strategija
            this.fxcon.azuriranjeStrategija.setOnAction(oas);   
         // 3. Informacije o programu
            // 3.1 Autor programa
            this.fxcon.autorPrograma.setOnAction(new OsluskivacAutorPrograma(this));
         // 4. Izlaz iz programa
            // 4.1 Izlaz
            this.fxcon.izlaz.setOnAction(new OsluskivacIzlaz(this));
         
        
       
        
        // Inicijalizacija GUI sahovske table
        inicijalizacijaGUISahovskeTable(); 
        
        this.fxcon.dodajPutanju.setOnAction(new OsluskivacDodajPutanju(this));
        this.fxcon.obrisiPutanju.setOnAction(new OsluskivacObrisiPutanju(this));
        
    } 
     
     
    public void inicijalizacijaGUISahovskeTable()
    {   try {
              odrediSvetlinuPolja();
            } catch (NoSuchFieldException | IllegalArgumentException | IllegalAccessException ex) 
             { Logger.getLogger(KontrolerGUIGlavniMeni.class.getName()).log(Level.SEVERE, null, ex); }
       
         try {
             ocistiPolja();
             } catch (NoSuchFieldException ex) 
              { Logger.getLogger(KontrolerGUIGlavniMeni.class.getName()).log(Level.SEVERE, null, ex); }

    } 
    
     
    // 1.1 Start
    public void pronaciPutOdGornjegLevogDoDonjegDesnogUgla() throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException 
    {  inicijalizacijaGUISahovskeTable(); 
       Strategija str = procitajTekucuStrategiju();
       if (str == null)
         { //for(int i=0; i<strategija.length; i++)       
           //strategija[i] = Integer.parseInt(tekucaStrategija.charAt(i) + "");
           str.setIdStrategija(tekucaStrategija);
         } 
       
     TransferObjekatStrategijaMatrica tos = new TransferObjekatStrategijaMatrica();
     tos.setStr(str);
     // SO!!! 
     tos = kal.pronaciPutOdGornjegLevogDoDonjegDesnogUgla(tos);
     mat = konvertujListArrIntUMatricu (tos.getMatrica());
     oznaciPolja(mat);
    }
    
    
    // 2.1 Autor programa
    public void autorPrograma() 
     {  Alert infoAlert = new Alert(Alert.AlertType.INFORMATION);
        infoAlert.setTitle("Informacije o programu:");
        infoAlert.setHeaderText(null); 
        infoAlert.setContentText("Autor programa: prof. dr Sinisa Vlajic.\n\n" + "BU-FON-Katedra za softevrsko inzenjerstvo-SILAB"); 
        infoAlert.showAndWait();  
     }

    
    // 3.1 Izlaz
    public void izlazIzPrograma() {
          Platform.exit();
          System.exit(0);
    }
    
    
     public void postaviSlikuBroja(Image img, int x, int y)
    {   
        Button b = null;
        String nazivDugmeta = "p" + x + y;
        
        Class cls = this.fxcon.getClass(); 
        try { 
            Field field = cls.getDeclaredField(nazivDugmeta);
            b = (Button) field.get(this.fxcon);
        } catch (NoSuchFieldException | SecurityException | IllegalArgumentException | IllegalAccessException ex) {
            Logger.getLogger(FXMLDocumentController.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        if (img != null)
            b.setGraphic( new ImageView ( img ) );
        else
            b.setGraphic( new ImageView());
    }
    
        
    public void oznaciPolja(int mat[][]) throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException
      { int pomx=0, pomy=0; 
        int maks = 0;
        for (int x = 0; x < 8; x++)
           { for (int y = 0; y < 8; y++)
            {   if (mat[x][y] == 0)
                    postaviSlikuBroja(null,x,y);
                if (mat[x][y] != 0)
                 { postaviSlikuBroja(vratiSliku(String.valueOf(mat[x][y])),x,y);
                   if (mat[x][y] > maks)
                     { pomx = x;
                       pomy = y;
                       maks = mat[x][y];
                     }  
                  
                 }
            }
           }
        brojKorakaPutanje = maks;
        String nazivDugmeta = "p" + pomx + pomy;
        Class cls = this.fxcon.getClass(); 
        Field field = cls.getDeclaredField(nazivDugmeta);
        Button b = (Button) field.get(this.fxcon); 
        b.getStyleClass().add("konjicevskok-kraj");
      } 
    
    public Image vratiSliku(String broj)
    {   String location = "assets/icons/";
        String filename =  broj + ".png";
        Image slikaBroja = new Image(location + filename);
        return slikaBroja;

    }

  
   void ocistiPolja() throws NoSuchFieldException
      {     
        for (int x = 0; x < 8; x++)
           { for (int y = 0; y < 8; y++)
            {   String nazivDugmeta = "p" + x + y;
                Class cls = this.fxcon.getClass(); 
                Field field = cls.getDeclaredField(nazivDugmeta);
                postaviSlikuBroja(null,x,y);
               
            }
           }
      } 

   

 void odrediSvetlinuPolja() throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException
  {
    for (int x = 0; x < 8; x++)
             { for (int y = 0; y < 8; y++)
                {   boolean svetlina = ( (x + y) % 2 != 0 );
                    String nazivDugmeta = "p" + x + y;
                    Class cls = this.fxcon.getClass(); 
                    Field field = cls.getDeclaredField(nazivDugmeta);
                    Button b = (Button) field.get(this.fxcon); 
                    if (svetlina)
                     { b.getStyleClass().removeAll("konjicevskok-kraj");
                       b.getStyleClass().add("konjicevskok-polje-svetlo");
                     } 
                    else
                     { b.getStyleClass().removeAll("konjicevskok-kraj");
                       b.getStyleClass().add("konjicevskok-polje-tamno");
                     }  
                }   
             }
  } 
   

 Strategija procitajTekucuStrategiju()
  { 
    if (oas.vratiFXMLDocumentController() == null) 
      return null;
    if (oas.vratiFXMLDocumentController().kbStrategije == null)
     { return null;  
     } 
    Strategija str = oas.vratiFXMLDocumentController().kbStrategije.getSelectionModel().getSelectedItem();
    if (str == null)
      return null;
    String idStrategija = str.getIdStrategija();
    strategija = konvertujStringIDUNizID(idStrategija);
    fxcon.idStrategija.setText(idStrategija);
    return str;
  }     
 
 
 public void dodajPutanju()
   { 
     TransferObjekatStrategijaPutanja tos = new TransferObjekatStrategijaPutanja();
     Strategija str = procitajTekucuStrategiju();
     str.setBrojKoraka(brojKorakaPutanje);
     tos.setStr(str);
     
       
       List<IntArray> lia = new ArrayList<IntArray>();
       for(int i=0;i<8;i++)
         { IntArray ia = new IntArray();
           lia.add(i, ia);
               for(int j=0;j<8;j++)
               { ia.getItem().add(j, mat[i][j]); 
               }
            
         }      
     
    // mat[i][j] = ia.get(i).getItem().get(j);   
       
     // SO!!! 
     tos = kal.dodajPutanju(tos,lia);  
     poruka(tos.getPoruka());
     
     
   }      
 
 
 
 
 public void obrisiPutanju()
   {   /*Poruka p = new Poruka();
       new ObrisiPutanju().obrisiPutanju(strategija,p);
       if (p.poruka.equals("obrisana putanja"))
           { inicijalizacijaGUISahovskeTable();
             poruka("Obrisana je putanja!!!");
           }
       else
          if (p.poruka.equals("putanja ne postoji")) 
             poruka("Putanja ne postoji!!!"); 
          else 
            poruka("Putanja ne postoji - ne postoji strategija!!!");*/   
     
   }
 
 public void poruka(String poruka)
 {
    Alert infoAlert = new Alert(Alert.AlertType.INFORMATION);
    infoAlert.setTitle("Poruka:");
    infoAlert.setHeaderText(null); 
    infoAlert.setContentText(poruka); 
    infoAlert.showAndWait();  
 }
 
 
 public void postaviMat(int mat[][])
  {this.mat = mat;}    
 
 int vratiBrojKorakaPutanje()
   {return brojKorakaPutanje;}     
 
 public int[] konvertujStringIDUNizID(String idStrategija)
    { int strategija[] = new int[8];  
      for(int i=0;i<idStrategija.length();i++)
        strategija[i] = Integer.parseInt(idStrategija.charAt(i) + "");
      return strategija;
    }
 
 
 int [][] konvertujListArrIntUMatricu (List<IntArray> lia)
{ int mat[][] = new int [8][8];
  for(int i = 0; i<8;i++)    
           for(int j = 0; j<8;j++)    
               mat[i][j] = lia.get(i).getItem().get(j);  

  return mat;
}
 
}