/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package GUIKorisnik;


import Kontroler_client.TransferObjekatKorisnik;
import Kontroler_client.TransferObjekatIterator;
import Kontroler_client.Kontroler_Service;
import Kontroler_client.Kontroler;
import Kontroler_client.Korisnik;
import GUIKorisnik.GUIOsluskivaci.*;


import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.ZoneId;
import java.util.Date;
import javafx.application.Platform;
import javafx.scene.control.Alert;
import java.util.GregorianCalendar;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;




/**
 *
 * @author Sinisa
 */
public class KontrolerGUIKorisnik {
     FXMLDocumentController fxcon;
     TransferObjekatIterator toi;
     
    
     
     Kontroler_Service service;
     Kontroler kal;
     
     public KontrolerGUIKorisnik(FXMLDocumentController fxcon) throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException
        {this.fxcon = fxcon;
         this.fxcon.izlaz.setOnAction(e->izlazIzPrograma());
         this.fxcon.kreirajKorisnika.setOnAction(new OsluskivacKreirajKorisnika(this));
         this.fxcon.promeniKorisnika.setOnAction(new OsluskivacPromeniKorisnika(this));
         this.fxcon.obrisiKorisnika.setOnAction(new OsluskivacObrisiKorisnika(this));
         this.fxcon.naPrvi.setOnAction(new OsluskivacNaPrvi(this));
         this.fxcon.naPoslednji.setOnAction(new OsluskivacNaPoslednji(this));
         this.fxcon.naSledeci.setOnAction(new OsluskivacNaSledeci(this));
         this.fxcon.naPredhodni.setOnAction(new OsluskivacNaPredhodni(this));
         this.fxcon.idKorisnika.setOnAction(new OsluskivacIDKorisnika(this));
         this.fxcon.idKorisnika.setOnMouseExited(new OsluskivacIDKorisnika(this));
         
         service = new Kontroler_Service();
         kal = service.getKontrolerPort();
         
         Korisnik kor = new Korisnik();
         
         
         toi = new TransferObjekatIterator();
         
         //DbIterator it = new DbIterator();
         
         //toi.setIt(it);
         //toi.getIt().setGdo(kor);
         
         //toi.setCurrentRecord(-1);
                  
         naPrvi();
         

         
    } 
     
     
 
 public void poruka(String poruka)
 {
    Alert infoAlert = new Alert(Alert.AlertType.INFORMATION);
    infoAlert.setTitle("Poruka:");
    infoAlert.setHeaderText(null); 
    infoAlert.setContentText(poruka); 
    infoAlert.showAndWait();  
 }
 
 
// Radi
/*public void kreirajKorisnika()
 {      Korisnik1 kor = new Korisnik1();
        kor.setIme("Pera");
        //TransferObjekatKorisnik tok = new TransferObjekatKorisnik();
        //tok.setKor(kor);
        //tok.setPoruka("prekosutra");
        //tok.setSignal(false);
        //Poruka por = new Poruka();
        //por.setPoruka("pre");
        kor = kal.kreirajKorisnika1(kor);
        //if (tok.isSignal())
          //{ //napuniFormuIzObjekta(kor);
          //} 
        //poruka(tok.getPoruka());
       poruka (kor.getIme());
          
 }*/    

/* radi
public void kreirajKorisnika()
 {      Korisnik1 kor = new Korisnik1();
        kor.setIme("Pera");
        TransferObjekatKorisnik tok = new TransferObjekatKorisnik();
        tok.setKor(kor);
        tok.setPoruka("prekosutra");
        tok.setSignal(false);
        //Poruka por = new Poruka();
        //por.setPoruka("pre");
        tok = kal.kreirajKorisnika1(tok);
        //if (tok.isSignal())
          //{ //napuniFormuIzObjekta(kor);
          //} 
        //poruka(tok.getPoruka());
       poruka (tok.getObj().getIme() + "----" + tok.getPoruka());
          
 } */


public void kreirajKorisnika()
 {      Korisnik kor = new Korisnik();
        kor.setIme("Pera");
        TransferObjekatKorisnik tok = new TransferObjekatKorisnik();
        tok.setKor(kor);
        tok.setPoruka("prekosutra");
        tok.setSignal(false);
        
        tok = kal.kreirajKorisnika(tok);
        if (tok.isSignal())
          { poruka("Datum:" + tok.getKor().getDatumRodjenja().toString());
            napuniFormuIzObjekta(tok.getKor());
          } 
        poruka(tok.getPoruka());
       //poruka (tok.getObj().getIme() + "----" + tok.getPoruka());
          
 } 




public void promeniKorisnika() 
 {      Korisnik kor = napuniObjekatIzForme();
        if ( kor!=null)
         {  
            TransferObjekatKorisnik tok = new TransferObjekatKorisnik();
            tok.setKor(kor);
            tok.setPoruka("");
            tok.setSignal(false);
            tok = kal.promeniKorisnika(tok);
            poruka(tok.getPoruka());
         }    
 }  
 
public void obrisiKorisnika()
 {   Korisnik kor = napuniObjekatIzForme();
     if ( kor!=null)
     {
       TransferObjekatKorisnik tok = new TransferObjekatKorisnik();
       tok.setKor(kor);
       tok.setPoruka("");
       tok.setSignal(Boolean.FALSE);
       tok = kal.obrisiKorisnika(tok);
       if (tok.isSignal())
         { naPrvi();
         } 
       poruka(tok.getPoruka()); 
     }  
 }


public void nadjiKorisnika()
 {   Korisnik kor = napuniObjekatIzForme();
     TransferObjekatKorisnik tok = new TransferObjekatKorisnik();
     tok.setKor(kor);
     tok.setPoruka("");
     tok.setSignal(Boolean.FALSE);
     tok = kal.nadjiKorisnika(tok);
     if (tok.isSignal())
        { napuniFormuIzObjekta(tok.getKor());
        } 
     else
       { napuniPraznuFormu();   
       }
     toi.setCurrentRecord(tok.getPozicija());
     //poruka(tok.getPoruka()); 
 }


public void naPrvi()
 { Korisnik kor = new Korisnik();
   toi.setObj(kor);
   toi = kal.first(toi);
   if (toi.getObj()!=null)
     napuniFormuIzObjekta((Korisnik)toi.getObj());
   else
     napuniPraznuFormu();  
 }

public void naPredhodni()
 { Korisnik kor = new Korisnik();
   toi.setObj(kor);
     
   toi = kal.previous(toi);
   if (toi.getObj()!=null)
     napuniFormuIzObjekta((Korisnik)toi.getObj());
   else
     napuniPraznuFormu();  
 }

public void naSledeci()
 { Korisnik kor = new Korisnik();
   toi.setObj(kor);
     
   toi = kal.next(toi);
   if (toi.getObj()!=null)
     napuniFormuIzObjekta((Korisnik)toi.getObj());
   else
     napuniPraznuFormu();  
 }

public void naPoslednji()
 { Korisnik kor = new Korisnik();
   toi.setObj(kor);
     
   toi = kal.last(toi);
   if (toi.getObj()!=null)
     napuniFormuIzObjekta((Korisnik)toi.getObj());
   else
     napuniPraznuFormu();   
 }
 

  public void izlazIzPrograma() {
          Platform.exit();
          System.exit(0);
    }
 
  
  public Korisnik napuniObjekatIzForme()
    { Korisnik kor = new Korisnik();
      try {
      kor.setIdKorisnik(Integer.parseInt(fxcon.idKorisnika.getText()));
      kor.setKorisnickoIme(fxcon.korisnickoIme.getText());
      kor.setSifra(fxcon.sifra.getText());
      kor.setIme(fxcon.ime.getText());
      kor.setPrezime(fxcon.prezime.getText());
      kor.setDatumRodjenja(konvertujLocalDateUXMLGregorianCalendar(fxcon.datumRodjenja.getValue()));
       } catch(Exception e) {poruka("Nisu ispravno uneta polja forme!!!"); return null;}
      return kor;
    }
  
  
  XMLGregorianCalendar konvertujLocalDateUXMLGregorianCalendar(LocalDate date)
    {  GregorianCalendar gcal = GregorianCalendar.from(date.atStartOfDay(ZoneId.systemDefault()));
      XMLGregorianCalendar xcal = null;
         try {
             xcal = DatatypeFactory.newInstance().newXMLGregorianCalendar(gcal);
         } catch (DatatypeConfigurationException ex) {
             Logger.getLogger(KontrolerGUIKorisnik.class.getName()).log(Level.SEVERE, null, ex);
         }
       return xcal;  
    }
  
  
  public void napuniPraznuFormu()
    { 
      fxcon.idKorisnika.setText("");
      fxcon.korisnickoIme.setText("");
      fxcon.sifra.setText("");
      fxcon.ime.setText("");
      fxcon.prezime.setText("");
      //fxcon.datumRodjenja.setValue(""));
    }
  
  
  public void napuniFormuIzObjekta(Korisnik kor)
    { 
      fxcon.idKorisnika.setText(String.valueOf(kor.getIdKorisnik()));
      fxcon.korisnickoIme.setText(kor.getKorisnickoIme());
      fxcon.sifra.setText(kor.getSifra());
      fxcon.ime.setText(kor.getIme());
      fxcon.prezime.setText(kor.getPrezime());
      fxcon.datumRodjenja.setValue(kor.getDatumRodjenja().toGregorianCalendar().toZonedDateTime().toLocalDate());
    }     
  
//private SimpleDateFormat dateFormat = new SimpleDateFormat("dd.MM.yyyy");  
  
  
  /*public class DateTimeAdapter extends XmlAdapter<String, Date>
  { private final DateFormat dateFormat = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss"); 
     @Override public Date unmarshal(String xml) throws Exception { return dateFormat.parse(xml);}
     @Override public  String marshal(Date object) throws Exception { return dateFormat.format(object); } 
  }*/

  
  
  public LocalDate setDatum(java.sql.Date input) 
    {   java.util.Date Datum = konvertujIzSQLDateUJavaUtilDate(input);
        LocalDate date = Datum.toInstant().atZone(ZoneId.systemDefault()).toLocalDate(); // konvertuje java.util.Date u LocalDate
        return date; 
    } 
  
    public LocalDate konvertujUtilDateULocalDate(java.util.Date input) 
    {   
        LocalDate date = input.toInstant().atZone(ZoneId.systemDefault()).toLocalDate(); // konvertuje java.util.Date u LocalDate
        return date; 
    } 
    
    
    
    
    public static java.util.Date konvertujIzSQLDateUJavaUtilDate(java.sql.Date sqlDate) {
        java.util.Date javaDate = null;
        if (sqlDate != null) {
            javaDate = new Date(sqlDate.getTime());
        }
        return javaDate;
    }
    
    public static java.sql.Date konvertujLocalDateUSqlDate(LocalDate input )
      {
        SimpleDateFormat sm = new SimpleDateFormat("yyyy-MM-dd");
        java.util.Date date = java.sql.Date.valueOf(input);
        return java.sql.Date.valueOf(sm.format(date)); 
      }
    
    public static java.util.Date konvertujLocalDateUUtilDate(LocalDate input )
      {
        SimpleDateFormat sm = new SimpleDateFormat("yyyy-MM-dd");
        java.util.Date date = java.sql.Date.valueOf(input);
        return date; 
      }
    
}