/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package PoslovnaLogikaStruktura;

import java.io.Serializable;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;



/**
 *
 * @author Sinisa
 */
public class Korisnik  extends GeneralDObject implements Serializable{
    public int idKorisnik;
    String korisnickoIme;
    String sifra;
    String ime;
    String prezime;
    public Date datumRodjenja;
    
    public Korisnik()
      { this.idKorisnik = 0;
        this.korisnickoIme = "";
        this.sifra = "";
        this.ime = "";
        this.prezime = "";
        SimpleDateFormat sm = new SimpleDateFormat("yyyy-MM-dd");
        Date dDatum = new Date();
        datumRodjenja = java.sql.Date.valueOf(sm.format(dDatum)); 
      }
    
    
    public Korisnik(int idKorisnik,String korisnickoIme,String sifra,String ime,String prezime,java.sql.Date datumRodjenja)
      { this.idKorisnik = idKorisnik;
        this.korisnickoIme = korisnickoIme;
        this.sifra = sifra;
        this.ime = ime;
        this.prezime = prezime;
        this.datumRodjenja = datumRodjenja;
      } 
     
     // alternativni primarni kljuc     
     public Korisnik(String korisnickoIme)
      { this.korisnickoIme = korisnickoIme;
      }
    
    // primarni kljuc
    public Korisnik(int idKorisnik)
      { this.idKorisnik = idKorisnik;
      }
    
    public int getPrimaryKey()
      {return this.idKorisnik;}  
    
    public int getIDKorisnik()
      {return this.idKorisnik;}  
    
    public String getKorisnickoIme()
      {return this.korisnickoIme;}  
    
    public String getSifra()
      {return this.sifra;}  
    
    public String getIme()
      {return this.ime;}  
    
    public String getPrezime()
      {return this.prezime;}  
    
    public Date getDatumRodjenja()
      {return this.datumRodjenja;}  
    
    public void setIDKorisnika(int idKorisnik)
      {this.idKorisnik = idKorisnik;}    
    
    public void setKorisnickoIme(String korisnickoIme)
      {this.korisnickoIme = korisnickoIme;}  
    
    public void setSifra(String sifra)
      {this.sifra = sifra; }  
    
    public void setIme(String ime)
      {this.ime = ime;}  
    
    public void setPrezime(String prezime)
      {this.prezime = prezime;}  
    
    public void setDatumRodjenja(java.sql.Date datumRodjenja)
      {this.datumRodjenja = datumRodjenja;}
    
     public void setDatumRodjenja1(java.util.Date datumRodjenja)
      {SimpleDateFormat sm = new SimpleDateFormat("yyyy-MM-dd");
       this.datumRodjenja = java.sql.Date.valueOf(sm.format(datumRodjenja)); 
      }
    
    
    @Override
     public String getAtrValue() { return  idKorisnik + ", '" + korisnickoIme + "', '" + sifra + "', '" + ime + "', '" + prezime + "', '" + datumRodjenja + "'"; }

    @Override
    public String setAtrValue() {
        return "idKorisnik=" + idKorisnik + ", " + "korisnickoIme='" + korisnickoIme + "', " + "sifra='" + sifra + "', ime='" + ime + "', prezime='" + prezime + "', datumRodjenja='" + datumRodjenja + "'";           
    }

    @Override
    public String getClassName() {
        return "Korisnik";        
    }

    @Override
    public String getWhereCondition() {
        return "idKorisnik=" + idKorisnik;
    }

    @Override
    public String getNameByColumn(int column) {
        String names[] = {"idKorisnik","korisnickoIme","sifra","ime","prezime","datumRodjenja"}; 
        return names[column];
    }

    @Override
    public GeneralDObject getNewRecord(ResultSet rs) throws SQLException {
      return new Korisnik(rs.getInt("idKorisnik"),rs.getString("korisnickoIme"),rs.getString("sifra"),rs.getString("ime"),rs.getString("prezime"),(rs.getDate("datumRodjenja")));        
    }
    
}
