/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package PoslovnaLogikaStruktura;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Sinisa
 */
public class Strategija extends GeneralDObject{
    public String idStrategija;
    public int idKorisnik;
    public List <StanjeStrategije> lss = new ArrayList <> ();
    public List <Putanja> lput = new ArrayList <> ();
    public int brojKoraka;
    
  public Strategija()
    {}     
    
  public Strategija(String idStrategija, int idKorisnik, int brojKoraka)
      { this.idStrategija = idStrategija;
        this.idKorisnik = idKorisnik;
        this.brojKoraka = brojKoraka;
      }
    
    public Strategija(String idStrategija, int idKorisnik)
      { this.idStrategija = idStrategija;
        this.idKorisnik = idKorisnik;
        brojKoraka = -1;
      }    
    
    // Primarni kljuc
    public Strategija(String idStrategija)
      { this.idStrategija = idStrategija;
      }
    
    public void dodajStanjeStrategije(StanjeStrategije ss)
     { lss.add(ss);
     } 
    
    public void dodajPutanju(Putanja put)
     { lput.add(put);
     }

    public void dodajBrojKoraka(int brojKoraka)
     { this.brojKoraka = brojKoraka;
     }      
    
    public List <StanjeStrategije> vratiListuStrategija()
        {return lss;}
    
    public List <Putanja> vratiListuPutanja()
        {return lput;}
      
     public String vratiIDStrategija()
      { return idStrategija;}     
             
     public String toString() {
        return String.valueOf(idStrategija); }

    @Override
     public String getAtrValue() { return  "'" + idStrategija + "', " + idKorisnik + ", " + brojKoraka; }

    @Override
    public String setAtrValue() {
        return "idStrategija='" + idStrategija + "', " + "idKorisnik=" + idKorisnik + ", " + "brojKoraka=" + brojKoraka;           
    }

    @Override
    public String getClassName() {
        return "Strategija";        
    }

    @Override
    public String getWhereCondition() {
        return "idStrategija='" + idStrategija + "'";
    }

    @Override
    public String getNameByColumn(int column) {
        String names[] = {"idStrategija","idKorisnik","brojKoraka"}; 
        return names[column];
    }

    @Override
    public GeneralDObject getNewRecord(ResultSet rs) throws SQLException {
      return new Strategija(rs.getString("idStrategija"),rs.getInt("idKorisnik"),rs.getInt("brojKoraka"));        
    }
    
    
    public void konvertujNizStrategijaUIDStrategija(int []strategija)
      { idStrategija = "";
        for(int s:strategija)
        { idStrategija = idStrategija + s;}

      } 
    
    // o.2.1.1.3.2 (SO), strategija moze biti predstavljena preko idStrategija 
    // ili preko niza od 8 brojeva.
    public int[] konvertujIDStrategijauNizStrategija()
    { int strategija[] = new int[8];  
      for(int i=0;i<idStrategija.length();i++)
        strategija[i] = Integer.parseInt(idStrategija.charAt(i) + "");
      return strategija;
    }  
    
    @Override
    public boolean equals(Object o)
     { Strategija s = (Strategija)o;
       if (s==null)
           return false;
       if (idStrategija.equals(s.idStrategija))
         return true;
       return false;
     }    

    @Override
    public int getPrimaryKey() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    
}
