/* Napravi kontroler GUI koji ce da bude izmedje FXML kontrolera i poslovne logike. 
Napravi da se bira strategija. Napravi osluskivace i uradi projektovanje top-down.
Omoguci dodavanje i brisanje strategija iz liste.
Izbaci iz GUI-a suvisne funkcionalnosti (odredi strategiju, pripremi polja za unos strategije).
Izbaci datoteku da cita tekucu strategiju. Citaj tekucu strategiju preko GUIAzuriranjeStrategija.FXMLDocumentController.
Povezi program sa MySQl bazom podataka. Omogucio sam azuriranje Strategije i StanjaStrategije u bazi preko programa.
Omoguciti azuriranje Putanje u bazi podataka.
Omoguciti prijavljivanje i azuriranje Korisnika u bazi podataka.
Napravi transfer objekat kod poziva sistemskih operacija.
Omoguciti operaciju nadji korisnika.
Odvoj operacije iteratora od sistemskih operacija.
Za iterator razmisli da otvoris jednu konekciju.
*/

package GUIGlavniMeni;

import java.net.URL;
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;

/**
 *
 * @author Sinisa
 */
public class SSFX1 extends Application {
    FXMLDocumentController con;
    String idKorisnika;
    
    @Override
    public void start(Stage stage) throws Exception {
        /*Parent root = FXMLLoader.load(getClass().getResource("FXMLDocument.fxml"));
        
        Scene scene = new Scene(root);
        scene.getStylesheets().add("assets/stylesheet.css");
        stage.setScene(scene);
        
       
        
        stage.setTitle("Skakačev skok");
        stage.show();*/
        
        
        String resourcePath = "FXMLDocument.fxml";
        URL location = getClass().getResource(resourcePath);
        FXMLLoader fxmlLoader = new FXMLLoader(location);
        Parent root = fxmlLoader.load();
        con = (FXMLDocumentController) fxmlLoader.getController();
    
        con.idKorisnika.setText(idKorisnika);
        
        Scene scene = new Scene(root);
        scene.getStylesheets().add("assets/stylesheet.css");
        stage.setScene(scene);
        
        stage.setTitle("Skakačev skok");
        stage.show();
        
        
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
    public FXMLDocumentController getController()
    { return con;} 
    
    public void postaviKorisnika (String idKorisnika)
     {
       this.idKorisnika = idKorisnika;
     }     
    
    public String vratiIDKorisnika ()
     {
       return idKorisnika;
     }
    
}
