/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package GUIPrijavljivanje;


import Kontroler_client.Kontroler;
import Kontroler_client.Kontroler_Service;
import Kontroler_client.TransferObjekatPrijavljivanje;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.scene.control.Alert;
import javafx.stage.Stage;



/**
 *
 * @author Sinisa
 */
public class KontrolerPrijavljivanje {
     FXMLDocumentController fxcon;
     
     
     Kontroler_Service service;
     Kontroler kal;
    
     public KontrolerPrijavljivanje(FXMLDocumentController fxcon) throws NoSuchFieldException, IllegalArgumentException, IllegalAccessException
      {  this.fxcon = fxcon;
         this.fxcon.prijavljivanje.setOnAction(new OsluskivacPrijavljivanje(this));
        
         service = new Kontroler_Service();
         kal = service.getKontrolerPort();
         
    } 
     
     
 
 public void poruka(String poruka)
 {
    Alert infoAlert = new Alert(Alert.AlertType.INFORMATION);
    infoAlert.setTitle("Poruka:");
    infoAlert.setHeaderText(null); 
    infoAlert.setContentText(poruka); 
    infoAlert.showAndWait();  
 }
 
 

 
public void prijavljivanje() 
 {   
     
    TransferObjekatPrijavljivanje top = new TransferObjekatPrijavljivanje();
    top.setKorisnickoIme(fxcon.korisnickoIme.getText());
    top.setSifra(fxcon.sifra.getText());
    top = kal.proveraPrijavljivanja(top);
    if (top.isSignal())
     {  GUIGlavniMeni.SSFX1 ssfx1;   
        Stage s;
        ssfx1 = new GUIGlavniMeni.SSFX1(); 
        s = new Stage();
        String idKorisnika = String.valueOf(top.getIdKorisnika());
         try {
             ssfx1.postaviKorisnika(idKorisnika);
             ssfx1.start(s);
             
             fxcon.zatvoriFormu();
         } catch (Exception ex) {
             Logger.getLogger(KontrolerPrijavljivanje.class.getName()).log(Level.SEVERE, null, ex);
         }
     }
    poruka(top.getPoruka());
         
}      


}