/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Kontroler;

import java.util.List;
import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.UriInfo;
import javax.xml.bind.JAXBElement;
import javax.xml.namespace.QName;

/**
 * REST Web Service
 *
 * @author Sinisa
 */
@Path("kontrolerport")
public class KontrolerPort {

    private Kontroler_client.Kontroler port;

    @Context
    private UriInfo context;

    /**
     * Creates a new instance of KontrolerPort
     */
    public KontrolerPort() {
        port = getPort();
    }

    /**
     * Invokes the SOAP method next
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatIterator>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("next/")
    public JAXBElement<Kontroler_client.TransferObjekatIterator> postNext(JAXBElement<Kontroler_client.TransferObjekatIterator> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatIterator result = port.next(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatIterator>(new QName("http//Kontroler_client/", "transferobjekatiterator"), Kontroler_client.TransferObjekatIterator.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method first
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatIterator>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("first/")
    public JAXBElement<Kontroler_client.TransferObjekatIterator> postFirst(JAXBElement<Kontroler_client.TransferObjekatIterator> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatIterator result = port.first(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatIterator>(new QName("http//Kontroler_client/", "transferobjekatiterator"), Kontroler_client.TransferObjekatIterator.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method previous
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatIterator>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("previous/")
    public JAXBElement<Kontroler_client.TransferObjekatIterator> postPrevious(JAXBElement<Kontroler_client.TransferObjekatIterator> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatIterator result = port.previous(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatIterator>(new QName("http//Kontroler_client/", "transferobjekatiterator"), Kontroler_client.TransferObjekatIterator.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method last
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatIterator>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("last/")
    public JAXBElement<Kontroler_client.TransferObjekatIterator> postLast(JAXBElement<Kontroler_client.TransferObjekatIterator> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatIterator result = port.last(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatIterator>(new QName("http//Kontroler_client/", "transferobjekatiterator"), Kontroler_client.TransferObjekatIterator.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method dodajPutanju
     * @param arg0 resource URI parameter
     * @param arg1 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatStrategijaPutanja>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("dodajputanju/")
    public JAXBElement<Kontroler_client.TransferObjekatStrategijaPutanja> postDodajPutanju(JAXBElement<Kontroler_client.TransferObjekatStrategijaPutanja> arg0, JAXBElement<List<Kontroler_client.IntArray>> arg1) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatStrategijaPutanja result = port.dodajPutanju(arg0.getValue(), arg1.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatStrategijaPutanja>(new QName("http//Kontroler_client/", "transferobjekatstrategijaputanja"), Kontroler_client.TransferObjekatStrategijaPutanja.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method pronaciPutOdGornjegLevogDoDonjegDesnogUgla
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("pronaciputodgornjeglevogdodonjegdesnogugla/")
    public JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica> postPronaciPutOdGornjegLevogDoDonjegDesnogUgla(JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatStrategijaMatrica result = port.pronaciPutOdGornjegLevogDoDonjegDesnogUgla(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica>(new QName("http//Kontroler_client/", "transferobjekatstrategijamatrica"), Kontroler_client.TransferObjekatStrategijaMatrica.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method promeniKorisnika
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatKorisnik>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("promenikorisnika/")
    public JAXBElement<Kontroler_client.TransferObjekatKorisnik> postPromeniKorisnika(JAXBElement<Kontroler_client.TransferObjekatKorisnik> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatKorisnik result = port.promeniKorisnika(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatKorisnik>(new QName("http//Kontroler_client/", "transferobjekatkorisnik"), Kontroler_client.TransferObjekatKorisnik.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method kreirajKorisnika
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatKorisnik>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("kreirajkorisnika/")
    public JAXBElement<Kontroler_client.TransferObjekatKorisnik> postKreirajKorisnika(JAXBElement<Kontroler_client.TransferObjekatKorisnik> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatKorisnik result = port.kreirajKorisnika(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatKorisnik>(new QName("http//Kontroler_client/", "transferobjekatkorisnik"), Kontroler_client.TransferObjekatKorisnik.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method obrisiKorisnika
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatKorisnik>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("obrisikorisnika/")
    public JAXBElement<Kontroler_client.TransferObjekatKorisnik> postObrisiKorisnika(JAXBElement<Kontroler_client.TransferObjekatKorisnik> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatKorisnik result = port.obrisiKorisnika(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatKorisnik>(new QName("http//Kontroler_client/", "transferobjekatkorisnik"), Kontroler_client.TransferObjekatKorisnik.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method nadjiKorisnika
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatKorisnik>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("nadjikorisnika/")
    public JAXBElement<Kontroler_client.TransferObjekatKorisnik> postNadjiKorisnika(JAXBElement<Kontroler_client.TransferObjekatKorisnik> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatKorisnik result = port.nadjiKorisnika(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatKorisnik>(new QName("http//Kontroler_client/", "transferobjekatkorisnik"), Kontroler_client.TransferObjekatKorisnik.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method proveraPrijavljivanja
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatPrijavljivanje>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("proveraprijavljivanja/")
    public JAXBElement<Kontroler_client.TransferObjekatPrijavljivanje> postProveraPrijavljivanja(JAXBElement<Kontroler_client.TransferObjekatPrijavljivanje> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatPrijavljivanje result = port.proveraPrijavljivanja(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatPrijavljivanje>(new QName("http//Kontroler_client/", "transferobjekatprijavljivanje"), Kontroler_client.TransferObjekatPrijavljivanje.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method vratiMatricuSahovskeTableSaPutanjom
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("vratimatricusahovsketablesaputanjom/")
    public JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica> postVratiMatricuSahovskeTableSaPutanjom(JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatStrategijaMatrica result = port.vratiMatricuSahovskeTableSaPutanjom(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica>(new QName("http//Kontroler_client/", "transferobjekatstrategijamatrica"), Kontroler_client.TransferObjekatStrategijaMatrica.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method vratiMatricuSahovskeTableSaStrategijom
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("vratimatricusahovsketablesastrategijom/")
    public JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica> postVratiMatricuSahovskeTableSaStrategijom(JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatStrategijaMatrica result = port.vratiMatricuSahovskeTableSaStrategijom(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatStrategijaMatrica>(new QName("http//Kontroler_client/", "transferobjekatstrategijamatrica"), Kontroler_client.TransferObjekatStrategijaMatrica.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method vratiListuStrategija
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatListaStrategija>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("vratilistustrategija/")
    public JAXBElement<Kontroler_client.TransferObjekatListaStrategija> postVratiListuStrategija(JAXBElement<Kontroler_client.TransferObjekatListaStrategija> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatListaStrategija result = port.vratiListuStrategija(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatListaStrategija>(new QName("http//Kontroler_client/", "transferobjekatlistastrategija"), Kontroler_client.TransferObjekatListaStrategija.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method dodajStrategiju
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatStrategija>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("dodajstrategiju/")
    public JAXBElement<Kontroler_client.TransferObjekatStrategija> postDodajStrategiju(JAXBElement<Kontroler_client.TransferObjekatStrategija> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatStrategija result = port.dodajStrategiju(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatStrategija>(new QName("http//Kontroler_client/", "transferobjekatstrategija"), Kontroler_client.TransferObjekatStrategija.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     * Invokes the SOAP method obrisiStrategiju
     * @param arg0 resource URI parameter
     * @return an instance of javax.xml.bind.JAXBElement<Kontroler_client.TransferObjekatStrategija>
     */
    @POST
    @Produces("application/xml")
    @Consumes("application/xml")
    @Path("obrisistrategiju/")
    public JAXBElement<Kontroler_client.TransferObjekatStrategija> postObrisiStrategiju(JAXBElement<Kontroler_client.TransferObjekatStrategija> arg0) {
        try {
            // Call Web Service Operation
            if (port != null) {
                Kontroler_client.TransferObjekatStrategija result = port.obrisiStrategiju(arg0.getValue());
                return new JAXBElement<Kontroler_client.TransferObjekatStrategija>(new QName("http//Kontroler_client/", "transferobjekatstrategija"), Kontroler_client.TransferObjekatStrategija.class, result);
            }
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }

    /**
     *
     */
    private Kontroler_client.Kontroler getPort() {
        try {
            // Call Web Service Operation
            Kontroler_client.Kontroler_Service service = new Kontroler_client.Kontroler_Service();
            Kontroler_client.Kontroler p = service.getKontrolerPort();
            return p;
        } catch (Exception ex) {
            // TODO handle custom exceptions here
        }
        return null;
    }
}
